#include <glib.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>
#include <math.h>
#include <iostream.h>
#include <fstream.h>
#include <signal.h>
#include "hftfakedata.h"
#include "hftdata.h"

#define CHIP_NUMBER  10
#define CHIP_ERROR  9
  void clear (GtkWidget *widget);

  void my_undate (GtkWidget *widget, gdouble x, gdouble y,gdouble width, gdouble height);
  void my_brush (GtkWidget *widget,GdkPixmap *pixmap, gdouble x, gdouble y,gdouble width, gdouble height,GdkColor * color);


 gboolean
show_1_button_press_event( GtkWidget *widget, GdkEventButton *event );
 gboolean
show_1_configure_event( GtkWidget *widget, GdkEventConfigure *event,int data);
 gboolean
show_1_expose_event( GtkWidget *widget, GdkEventExpose *event,int data);
 gboolean
show_1_motion_notify_event( GtkWidget *widget, GdkEventMotion *event );

 
 void show_1_draw_brush (GtkWidget *widget, gdouble x, gdouble y,int chip);

 gboolean
button_press_event( GtkWidget *widget, GdkEventButton *event );
 gboolean
configure_event( GtkWidget *widget, GdkEventConfigure *event );
 gboolean
expose_event( GtkWidget *widget, GdkEventExpose *event );
 gboolean
motion_notify_event( GtkWidget *widget, GdkEventMotion *event );
 
 
 void draw_brush (GtkWidget *widget, gdouble x, gdouble y);

 void destroy( GtkWidget *widget, gpointer data );

 void show_1_destroy( GtkWidget *widget, int data );

 
 
 void enter_callback( GtkWidget *widget,
                            GtkWidget *entry );
void main_Expert( GtkWidget *widget );
void main_Reset( GtkWidget *widget );
void main_Run( GtkWidget *widget );
void main_Stop( GtkWidget *widget );

void set_timer();
void sigalrm_handler(int sig);
 void expert_destroy( GtkWidget *widget, int data );
 void display_staus( int * error, int chip );
void display_chip( int * address, int length,int chip );
void expert_enter_callback( GtkWidget *widget,
                            GtkWidget *entry );



 GdkPixmap *pixmap = NULL;
 GdkPixmap **show_1_pixmap = new GdkPixmap*[CHIP_NUMBER];


  GtkWidget *main_window;
  GtkWidget *main_button_reset, *main_button_run, *main_button_stop,*main_button_hot, *main_button_expert;
  GtkWidget *main_boxl;
  GtkWidget *main_hbox;
  GtkStyle  *main_style;



	GtkWidget *display_1_window;
	GtkDrawingArea *display_1_drawing_area;
    GtkWidget *display_1_vbox;
    GtkWidget *display_1_entry;



	GtkWidget **show_1_window;
	GtkDrawingArea **show_1_drawing_area;
    GtkWidget **show_1_vbox;
    GtkWidget **show_1_entry;


	GtkWidget *expert_window;
	GtkDrawingArea *expert_drawing_area;
    GtkWidget *expert_vbox;
    GtkWidget *expert_entry;

	hftdata reader;
	hftfakedata writer;

int count = 0;
int file_counter = 0;
int chip_order = 0;
int zoomxs[CHIP_NUMBER];
int zoomxe[CHIP_NUMBER];
int zoomys[CHIP_NUMBER];
int zoomye[CHIP_NUMBER];
char filename[100];
char command[100];
gboolean expert_switch=FALSE;
gboolean timer_switch=FALSE;
gboolean stop_switch=FALSE;
gboolean file_switch=FALSE;

gboolean show_1_switch[CHIP_NUMBER];




void display_chip( int * address, int length,int chip )
{
if(show_1_switch[chip]==FALSE) return;
int i;
int x,y;
int zx=zoomxe[chip]-zoomxs[chip];
int zy=zoomye[chip]-zoomys[chip];
if(zx<=0||zy<=0) return;

int unitx=300/zx;
int unity=300/zy;
if(unitx==0) unitx=1;
if(unity==0) unity=1;

//cout<<"zx "<<zx<<" zy "<<zy<<" unitx "<<unitx<<" unity "<<unity<<endl;
int rx;
int ry;

	GdkColor  bcolor,white;
    bcolor.red = 0;
    bcolor.green = 0;
    bcolor.blue = 65535;
    white.red = 65535;
    white.green = 65535;
    white.blue = 65535;

my_brush((GtkWidget *)show_1_drawing_area[chip],show_1_pixmap[chip],0,0,300,300,&white);

for(i=0;i<length;i++){
//writer.backaddr(address[i],x,y);

x=address[i]%660;
y=address[i]/660;
//cout<<"x= "<<x<<" y= "<<y<<endl;
if(x<zoomxs[chip]) continue;
if(x>=zoomxe[chip]) continue;
if(y<zoomys[chip]) continue;
if(y>=zoomye[chip]) continue;

rx=((x-zoomxs[chip])*300)/zx;
ry=((y-zoomys[chip])*300)/zy;

if(show_1_switch[chip]==FALSE) return;
my_brush((GtkWidget *)show_1_drawing_area[chip],show_1_pixmap[chip],rx,ry,unitx,unitx,&bcolor);

}

	my_undate((GtkWidget *)show_1_drawing_area[chip],0,0,300,300);
}

void display_staus( int * error, int chip ){

int dense=abs(rand())%32768+32768;


	int xp=chip%3;
    int yp=chip/3;
	GdkColor  gcolor,rcolor,bcolor;
    gcolor.red = 0;
    gcolor.green = dense;
    gcolor.blue = 0;
    rcolor.red = dense;
    rcolor.green = 0;
    rcolor.blue = 0;
    bcolor.red = 0;
    bcolor.green = 0;
    bcolor.blue = 65535;

	my_brush((GtkWidget *)display_1_drawing_area,pixmap,100*xp,100*yp,100,100,&bcolor);

	int i,x,y;
	for(i=0;i<CHIP_ERROR;i++){
	x=i%3;
    y=i/3;	
	if(error[i]==0){
	my_brush((GtkWidget *)display_1_drawing_area,pixmap,100*xp+2+32*x,100*yp+2+32*y,32,32,&rcolor);
	}else
	{
	my_brush((GtkWidget *)display_1_drawing_area,pixmap,100*xp+2+32*x,100*yp+2+32*y,32,32,&gcolor);
	}
	}
	my_undate((GtkWidget *)display_1_drawing_area,100*xp,100*yp,100,100);

// CHIP_ERROR

}
void main_Reset( GtkWidget *widget )
{
  g_print("Reset\n");
  gtk_widget_hide(display_1_window);
  
}

void main_Run( GtkWidget *widget )
{
  g_print("Run\n");

//    gtk_widget_show(display_1_window);
stop_switch=TRUE;

}
void main_Hot( GtkWidget *widget )
{
  g_print("hot pixel\n");

}
void main_Stop( GtkWidget *widget )
{

	stop_switch=FALSE;


	GdkColor  color;
    color.red = 30000;
    color.green = 0;
    color.blue = 30000;
	//system("root -l");
	if(show_1_switch[0]==TRUE){
	my_brush((GtkWidget *)show_1_drawing_area[0],show_1_pixmap[0],100,100,20,20,&color);
	my_undate((GtkWidget *)show_1_drawing_area[0],100,100,20,20);
	}
  g_print("Stop\n");
  
}

void main_Expert( GtkWidget *widget )
{
  g_print("Expert\n");

  if(expert_switch==TRUE) return ;
expert_switch=TRUE;


/////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////


	




	
	expert_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(expert_window), 
		       "expert");
	expert_drawing_area = (GtkDrawingArea*)gtk_drawing_area_new ();
  gtk_widget_set_size_request ((GtkWidget*)expert_drawing_area, 300, 300);

   
    expert_vbox = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (expert_window), expert_vbox);
    gtk_widget_show (expert_vbox);
	
 //   gtk_box_pack_start (GTK_BOX (expert_vbox), (GtkWidget*)expert_drawing_area, TRUE, TRUE, 0);
 //   gtk_widget_show ((GtkWidget*)expert_drawing_area);


//	  hbox = gtk_hbox_new (FALSE, 0);
//    gtk_container_add (GTK_CONTAINER (vbox), hbox);
//    gtk_widget_show (hbox);


    expert_entry = gtk_entry_new ();
    gtk_entry_set_max_length (GTK_ENTRY (expert_entry), 50);
    g_signal_connect (G_OBJECT (expert_entry), "activate",
		      G_CALLBACK (expert_enter_callback),
		      (gpointer) expert_entry);
//    gtk_entry_set_text (GTK_ENTRY (entry), "hello");
  //  tmp_pos = GTK_ENTRY (entry)->text_length;
  //  gtk_editable_insert_text (GTK_EDITABLE (entry), " world", -1, &tmp_pos);
  //  gtk_editable_select_region (GTK_EDITABLE (entry),
	//		        0, GTK_ENTRY (entry)->text_length);
    gtk_box_pack_start (GTK_BOX (expert_vbox), expert_entry, TRUE, TRUE, 0);
    gtk_widget_show (expert_entry);
 
	


    /* This is called in all GTK applications. Arguments are parsed
     * from the command line and are returned to the application. */

    
    /* create a new window */
       
    g_signal_connect( G_OBJECT (expert_drawing_area), "destroy",
		              G_CALLBACK (expert_destroy), NULL );  
	  gtk_signal_connect (GTK_OBJECT (expert_drawing_area), "expose_event",
		      (GtkSignalFunc) expose_event, NULL);
  gtk_signal_connect (GTK_OBJECT(expert_drawing_area),"configure_event",
		      (GtkSignalFunc) configure_event, NULL);

//  gtk_signal_connect (GTK_OBJECT (expert_drawing_area), "motion_notify_event",
//		      (GtkSignalFunc) motion_notify_event, NULL);
//  gtk_signal_connect (GTK_OBJECT (expert_drawing_area), "button_press_event",
//		      (GtkSignalFunc) button_press_event, NULL);

  gtk_widget_set_events ((GtkWidget*)expert_drawing_area, GDK_EXPOSURE_MASK
			 | GDK_LEAVE_NOTIFY_MASK
//			 | GDK_BUTTON_PRESS_MASK
			 | GDK_POINTER_MOTION_MASK
			 | GDK_POINTER_MOTION_HINT_MASK);

//gtk_container_add (GTK_CONTAINER (window), drawing_area);


    gtk_widget_show ((GtkWidget*)expert_drawing_area);
    gtk_widget_show (expert_window);
///////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////




}

 void enter_callback( GtkWidget *widget,
                            GtkWidget *entry )
{
  const gchar *entry_text;
  entry_text = gtk_entry_get_text (GTK_ENTRY (widget));
  printf ("Entry contents: %s\n", entry_text);
  	clear(entry);
}
void expert_enter_callback( GtkWidget *widget,
                            GtkWidget *entry )
{
  const gchar *entry_text;
  entry_text = gtk_entry_get_text (GTK_ENTRY (widget));
  printf ("Entry contents: %s\n", entry_text);
  gtk_entry_set_text (GTK_ENTRY (entry), "");
  	clear(entry);
}
void set_timer()
{
        struct itimerval itv, oldtv;
        itv.it_interval.tv_sec = 0;
        itv.it_interval.tv_usec = 50000;
        itv.it_value.tv_sec = 1;
        itv.it_value.tv_usec = 50000;

        setitimer(ITIMER_REAL, &itv, &oldtv);
}

void sigalrm_handler(int sig)
{

	if(stop_switch==FALSE) return;
	if(timer_switch==TRUE) return;
timer_switch=TRUE;


	char s[100];
sprintf(s,"sun.sun",file_counter);
//cout<<"file_counter  "<<file_counter<<endl;

if(file_switch==FALSE){
	if(reader.openfile(s)==0) {timer_switch=FALSE;return;}
	else{
	file_switch=TRUE;
	file_counter++;
	}
}

int val=reader.get();

if(val==-1||val==0){	file_switch=FALSE; timer_switch=FALSE;
sprintf(command,"cat %s>>%s",s,filename);
system(command);
sprintf(command,"rm -f %s",s);
system(command);

return;
}
//	chip_order++;

//chip_order=(chip_order)%9;

int error[CHIP_ERROR];

	for(int i=0;i<CHIP_ERROR;i++)
		error[i]=1;


display_staus(error,reader.chip_id%3);
display_chip((int *)reader.data,reader.length,reader.chip_id%3);

timer_switch=FALSE;
        //count++;
        //printf("timer signal.. %d\n", count);
}


 void destroy( GtkWidget *widget, gpointer data )
 { 
    gtk_main_quit ();
}

 void show_1_destroy( GtkWidget *widget, int data )
{
	 show_1_switch[data]=FALSE;
    printf ("counter is: %d\n", data);
}
 void expert_destroy( GtkWidget *widget, int data )
{
	 expert_switch=FALSE;
    //printf ("counter is: %d\n", data);
}
 void show_1_draw_brush (GtkWidget *widget, gdouble x, gdouble y,int chip)
{
    GdkGC *gc1, *gc2, *gc;
    GdkColor color;

    gc1 = gdk_gc_new( widget->window );
    color.red = 30000;
    color.green = 0;
    color.blue = 30000;
    gdk_gc_set_rgb_fg_color(gc1, &color );

    gc2 = gdk_gc_new( widget->window );
    color.red = 65535;
    color.green = 0;
    color.blue = 0;
    gdk_gc_set_rgb_fg_color( gc2, &color );

    gc = gc2;


  GdkRectangle update_rect;

  update_rect.x = x - 1;
  update_rect.y = y - 1;
  update_rect.width = 10;
  update_rect.height = 10;
  gdk_draw_rectangle (pixmap,
  		      //widget->style->black_gc,
  		      gc,
			  TRUE,
		      update_rect.x, update_rect.y,
		      update_rect.width, update_rect.height);
  gtk_widget_queue_draw_area (widget, 		      
                              update_rect.x, update_rect.y,
		              update_rect.width, update_rect.height);
}


  void my_brush (GtkWidget *widget,GdkPixmap *pixmap, gdouble x, gdouble y,gdouble width, gdouble height,GdkColor * color)
{
    GdkGC *gc1;

    gc1 = gdk_gc_new( widget->window );

    gdk_gc_set_rgb_fg_color(gc1, color );




  GdkRectangle update_rect;

  update_rect.x = x ;
  update_rect.y = y ;
  update_rect.width = width;
  update_rect.height = height;
  gdk_draw_rectangle (pixmap,
  		      //widget->style->black_gc,
  		      gc1,
			  TRUE,
		      update_rect.x, update_rect.y,
		      update_rect.width, update_rect.height);
//  gtk_widget_queue_draw_area (widget, 		      
//                              update_rect.x, update_rect.y,
//		              update_rect.width, update_rect.height);
}

  void my_undate (GtkWidget *widget, gdouble x, gdouble y,gdouble width, gdouble height)
{


  gtk_widget_queue_draw_area (widget, 		      
                              x, y,
		              width, height);
}
 void draw_brush (GtkWidget *widget, gdouble x, gdouble y)
{
    GdkGC *gc1, *gc2, *gc;
    GdkColor color;

    gc1 = gdk_gc_new( widget->window );
    color.red = 30000;
    color.green = 0;
    color.blue = 30000;
    gdk_gc_set_rgb_fg_color(gc1, &color );

    gc2 = gdk_gc_new( widget->window );
    color.red = 65535;
    color.green = 0;
    color.blue = 0;
    gdk_gc_set_rgb_fg_color( gc2, &color );

    gc = gc2;


  GdkRectangle update_rect;

  update_rect.x = x - 1;
  update_rect.y = y - 1;
  update_rect.width = 1;
  update_rect.height = 1;
  gdk_draw_rectangle (pixmap,
  		      //widget->style->black_gc,
  		      gc,
			  TRUE,
		      update_rect.x, update_rect.y,
		      update_rect.width, update_rect.height);
  gtk_widget_queue_draw_area (widget, 		      
                              update_rect.x, update_rect.y,
		              update_rect.width, update_rect.height);
}

  void clear (GtkWidget *widget)
{
//	  draw_brush(widget,150,150);
  if (pixmap)
    g_object_unref(pixmap);

  pixmap = gdk_pixmap_new(widget->window,
			//  widget->allocation.width,
			//  widget->allocation.height,
			  300,
			  300,
			  -1);
  gdk_draw_rectangle (pixmap,
		      widget->style->white_gc,
		      TRUE,
		      0, 0,
		      //widget->allocation.width,
		      //widget->allocation.height
			  300,300
			  );

}
 gboolean
show_1_button_press_event( GtkWidget *widget, GdkEventButton *event )
{
  if (event->button == 1 && pixmap != NULL)
      show_1_draw_brush (widget, event->x, event->y,0);
//draw_brush (widget, 100, 100);
 }
 gboolean
button_press_event( GtkWidget *widget, GdkEventButton *event )
{
//  if (event->button == 1 && pixmap != NULL)
      //draw_brush (widget, event->x, event->y);
//draw_brush (widget, 100, 100);
count=int(event->x/100)+int(event->y/100)*3;
char s[100];
if(show_1_switch[count]==TRUE) return FALSE;
show_1_switch[count]=TRUE;
sprintf(s,"show_%d",count);
/////////////////////////////////////////////////////////////////////////////////////////////
////////////////////


	




	
	show_1_window[count] = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(show_1_window[count]), 
		       s);
	show_1_drawing_area[count] = (GtkDrawingArea*)gtk_drawing_area_new ();
  gtk_widget_set_size_request ((GtkWidget*)show_1_drawing_area[count], 300, 300);

   
    show_1_vbox[count] = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (show_1_window[count]), show_1_vbox[count]);
    gtk_widget_show (show_1_vbox[count]);
	
    gtk_box_pack_start (GTK_BOX (show_1_vbox[count]), (GtkWidget*)show_1_drawing_area[count], TRUE, TRUE, 0);
    gtk_widget_show ((GtkWidget*)show_1_drawing_area[count]);


//	hbox = gtk_hbox_new (FALSE, 0);
//    gtk_container_add (GTK_CONTAINER (vbox), hbox);
//    gtk_widget_show (hbox);


    show_1_entry[count] = gtk_entry_new ();
    gtk_entry_set_max_length (GTK_ENTRY (show_1_entry[count]), 50);
    g_signal_connect (G_OBJECT (show_1_entry[count]), "activate",
		      G_CALLBACK (enter_callback),
		      (gpointer) show_1_drawing_area[count]);
  //  gtk_entry_set_text (GTK_ENTRY (entry), "hello");
  //  tmp_pos = GTK_ENTRY (entry)->text_length;
  //  gtk_editable_insert_text (GTK_EDITABLE (entry), " world", -1, &tmp_pos);
  //  gtk_editable_select_region (GTK_EDITABLE (entry),
  //		        0, GTK_ENTRY (entry)->text_length);
    gtk_box_pack_start (GTK_BOX (show_1_vbox[count]), show_1_entry[count], TRUE, TRUE, 0);
    gtk_widget_show (show_1_entry[count]);
 
	


    /* This is called in all GTK applications. Arguments are parsed
     * from the command line and are returned to the application. */

    
    /* create a new window */
    g_signal_connect( G_OBJECT (show_1_drawing_area[count]), "destroy",
		              G_CALLBACK (show_1_destroy), (void*)count );       

	  gtk_signal_connect (GTK_OBJECT (show_1_drawing_area[count]), "expose_event",
		      (GtkSignalFunc) show_1_expose_event, (void*)count);
  gtk_signal_connect (GTK_OBJECT(show_1_drawing_area[count]),"configure_event",
		      (GtkSignalFunc) show_1_configure_event, (void*)count);
//  gtk_signal_connect (GTK_OBJECT (show_1_drawing_area[count]), "motion_notify_event",
//		      (GtkSignalFunc) show_1_motion_notify_event, NULL);
//  gtk_signal_connect (GTK_OBJECT (show_1_drawing_area[count]), "button_press_event",
//		      (GtkSignalFunc) show_1_button_press_event, NULL);

  gtk_widget_set_events ((GtkWidget*)show_1_drawing_area[count], GDK_EXPOSURE_MASK
			 | GDK_LEAVE_NOTIFY_MASK
			 | GDK_BUTTON_PRESS_MASK
			 | GDK_POINTER_MOTION_MASK
			 | GDK_POINTER_MOTION_HINT_MASK);

//gtk_container_add (GTK_CONTAINER (window), drawing_area);


    gtk_widget_show ((GtkWidget*)show_1_drawing_area[count]);
    gtk_widget_show (show_1_window[count]);
///////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

  return TRUE;
}

 gboolean
show_1_motion_notify_event( GtkWidget *widget, GdkEventMotion *event )
{
  int x, y;
  GdkModifierType state;

  if (event->is_hint)
    gdk_window_get_pointer (event->window, &x, &y, &state);
  else
    {
      x = event->x;
      y = event->y;
      state = GdkModifierType(event->state);
    }
    
  if (state & GDK_BUTTON1_MASK && pixmap != NULL)
    show_1_draw_brush (widget, x, y,0);
  
  return TRUE;
}

 gboolean
motion_notify_event( GtkWidget *widget, GdkEventMotion *event )
{
  int x, y;
  GdkModifierType state;

  if (event->is_hint)
    gdk_window_get_pointer (event->window, &x, &y, &state);
  else
    {
      x = event->x;
      y = event->y;
      state = GdkModifierType(event->state);
    }
    
  if (state & GDK_BUTTON1_MASK && pixmap != NULL)
    //draw_brush (widget, x, y);
  
  return TRUE;
}

/* Backing pixmap for drawing area */

/* Create a new backing pixmap of the appropriate size */
 gboolean
show_1_configure_event( GtkWidget *widget, GdkEventConfigure *event,int data )
{
  if (show_1_pixmap[data])
    g_object_unref(show_1_pixmap[data]);

  show_1_pixmap[data] = gdk_pixmap_new(widget->window,
			  widget->allocation.width,
			  widget->allocation.height,
			  -1);
  gdk_draw_rectangle (show_1_pixmap[data],
		      widget->style->white_gc,
		      TRUE,
		      0, 0,
		      widget->allocation.width,
		      widget->allocation.height);

  return TRUE;
}


/* Redraw the screen from the backing pixmap */
/* Create a new backing pixmap of the appropriate size */

 gboolean
configure_event( GtkWidget *widget, GdkEventConfigure *event )
{
  if (pixmap)
    g_object_unref(pixmap);

  pixmap = gdk_pixmap_new(widget->window,
			  widget->allocation.width,
			  widget->allocation.height,
			  -1);
  gdk_draw_rectangle (pixmap,
		      widget->style->white_gc,
		      TRUE,
		      0, 0,
		      widget->allocation.width,
		      widget->allocation.height);

  return TRUE;
}
 gboolean
show_1_expose_event( GtkWidget *widget, GdkEventExpose *event,int data )
{
  gdk_draw_drawable(widget->window,
		    widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		    show_1_pixmap[data],
		    event->area.x, event->area.y,
		    event->area.x, event->area.y,
		    event->area.width, event->area.height);

  return FALSE;
}
/* Redraw the screen from the backing pixmap */
 gboolean
expose_event( GtkWidget *widget, GdkEventExpose *event )
{
  gdk_draw_drawable(widget->window,
		    widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		    pixmap,
		    event->area.x, event->area.y,
		    event->area.x, event->area.y,
		    event->area.width, event->area.height);

  return FALSE;
}

/* Draw a rectangle on the screen */


int main( int   argc,
          char *argv[] )
{  

reader.openfile("sun.sun");
	sprintf(filename,"%s",argv[1]);
	int i;
	for(i=0;i<CHIP_NUMBER;i++){
		show_1_switch[i]=FALSE;
 zoomxs[i]=0;
 zoomxe[i]=132;
 zoomys[i]=0;
 zoomye[i]=128;
	
	}

	gtk_init (&argc, &argv);

		show_1_window=new GtkWidget*[CHIP_NUMBER];
	 show_1_drawing_area=new GtkDrawingArea*[CHIP_NUMBER];
    show_1_vbox=new GtkWidget*[CHIP_NUMBER];
    show_1_entry=new GtkWidget*[CHIP_NUMBER];

/////////////////////////////////////////////////////////////////////////////////////////////
////////////////////


	  main_window=gtk_window_new( GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(main_window), 
		       "Heavy Flavor Tracker Event Display");

  main_style=gtk_widget_get_style(main_window);

gtk_container_set_border_width( GTK_CONTAINER(main_window),10);


  /* Define container box */
  main_boxl = gtk_hbox_new(FALSE,0);
  gtk_container_add(GTK_CONTAINER(main_window), main_boxl);



    main_button_reset=gtk_button_new_with_label("Reset");

  GdkColor ncolor;
      ncolor.red = 65535;
    ncolor.green = 0;
    ncolor.blue = 0;
  gtk_widget_modify_bg (main_button_reset, GTK_STATE_NORMAL, &ncolor);
  gtk_widget_modify_fg (main_button_reset, GTK_STATE_NORMAL, &ncolor);

 g_signal_connect(G_OBJECT(main_button_reset),"clicked",
			   G_CALLBACK(main_Reset),
			   NULL);

  gtk_box_pack_start(GTK_BOX(main_boxl),main_button_reset,TRUE,TRUE,0);
  gtk_widget_show(main_button_reset);
 
  main_button_hot=gtk_button_new_with_label("Hot");

  g_signal_connect(G_OBJECT(main_button_hot),"clicked",
			   G_CALLBACK(main_Hot),
			   NULL);

  gtk_box_pack_start(GTK_BOX(main_boxl),main_button_hot,TRUE,TRUE,0);
  gtk_widget_show(main_button_hot);

  main_button_run=gtk_button_new_with_label("Run");
  g_signal_connect(G_OBJECT(main_button_run),"clicked",
			   G_CALLBACK(main_Run),
			   NULL);

  gtk_box_pack_start(GTK_BOX(main_boxl),main_button_run,TRUE,TRUE,0);
  gtk_widget_show(main_button_run);


  main_button_stop=gtk_button_new_with_label("Stop");

  g_signal_connect(G_OBJECT(main_button_stop),"clicked",
			   G_CALLBACK(main_Stop),
			   NULL);

  gtk_box_pack_start(GTK_BOX(main_boxl),main_button_stop,TRUE,TRUE,0);
  gtk_widget_show(main_button_stop);


    main_button_expert=gtk_button_new_with_label("Expert");

  g_signal_connect(G_OBJECT(main_button_expert),"clicked",
			   G_CALLBACK(main_Expert),
			   NULL);

  gtk_box_pack_start(GTK_BOX(main_boxl),main_button_expert,TRUE,TRUE,0);
  gtk_widget_show(main_button_expert);

  gtk_widget_show(main_boxl);
  gtk_widget_show(main_window);
////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
////////////////////


	




	
	display_1_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(display_1_window), 
		       "display_1");
	display_1_drawing_area = (GtkDrawingArea*)gtk_drawing_area_new ();
  gtk_widget_set_size_request ((GtkWidget*)display_1_drawing_area, 300, 300);

   
    display_1_vbox = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (display_1_window), display_1_vbox);
    gtk_widget_show (display_1_vbox);
	
    gtk_box_pack_start (GTK_BOX (display_1_vbox), (GtkWidget*)display_1_drawing_area, TRUE, TRUE, 0);
    gtk_widget_show ((GtkWidget*)display_1_drawing_area);


//	hbox = gtk_hbox_new (FALSE, 0);
//    gtk_container_add (GTK_CONTAINER (vbox), hbox);
//    gtk_widget_show (hbox);


    display_1_entry = gtk_entry_new ();
    gtk_entry_set_max_length (GTK_ENTRY (display_1_entry), 50);
    g_signal_connect (G_OBJECT (display_1_entry), "activate",
		      G_CALLBACK (enter_callback),
		      (gpointer) display_1_drawing_area);
  //  gtk_entry_set_text (GTK_ENTRY (entry), "hello");
  //  tmp_pos = GTK_ENTRY (entry)->text_length;
  //  gtk_editable_insert_text (GTK_EDITABLE (entry), " world", -1, &tmp_pos);
  //  gtk_editable_select_region (GTK_EDITABLE (entry),
  //		        0, GTK_ENTRY (entry)->text_length);
    gtk_box_pack_start (GTK_BOX (display_1_vbox), display_1_entry, TRUE, TRUE, 0);
    gtk_widget_show (display_1_entry);
 
	


    /* This is called in all GTK applications. Arguments are parsed
     * from the command line and are returned to the application. */

    
    /* create a new window */
       
    g_signal_connect( G_OBJECT (display_1_window), "destroy",
		              G_CALLBACK (destroy), NULL );
	  gtk_signal_connect (GTK_OBJECT (display_1_drawing_area), "expose_event",
		      (GtkSignalFunc) expose_event, NULL);
  gtk_signal_connect (GTK_OBJECT(display_1_drawing_area),"configure_event",
		      (GtkSignalFunc) configure_event, NULL);
  gtk_signal_connect (GTK_OBJECT (display_1_drawing_area), "motion_notify_event",
		      (GtkSignalFunc) motion_notify_event, NULL);
  gtk_signal_connect (GTK_OBJECT (display_1_drawing_area), "button_press_event",
		      (GtkSignalFunc) button_press_event, NULL);

  gtk_widget_set_events ((GtkWidget*)display_1_drawing_area, GDK_EXPOSURE_MASK
			 | GDK_LEAVE_NOTIFY_MASK
			 | GDK_BUTTON_PRESS_MASK
			 | GDK_POINTER_MOTION_MASK
			 | GDK_POINTER_MOTION_HINT_MASK);

//gtk_container_add (GTK_CONTAINER (window), drawing_area);


    gtk_widget_show ((GtkWidget*)display_1_drawing_area);
    gtk_widget_show (display_1_window);
///////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////


    /* All GTK applications must have a gtk_main(). Control ends here
     * and waits for an event to occur (like a key press or
     * mouse event). */
	//draw_brush(drawing_area,10,10);
        signal(SIGALRM, sigalrm_handler);
        set_timer();
    gtk_main ();
    
    return 0;
}